<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"/>

<html>

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  <title>In the street with my laptop</title>
  <link rel="stylesheet" type="text/css" href="/main.css"/>
  <meta name="description" content="Personal website of a homeless guy, living with his laptop in the street in Luxembourg"/>
  <meta name="keywords" content="homeless, street, laptop, Luxembourg, programming, Lazarus, FreePascal, website, database, MySQL, Perl"/>
</head>

<body>
  <div class="container">
    <div class="header">
      <h1 class="title">In the street with my laptop</h1>
      <table align="center" border="0" width="96%">
        <tr>
          <td align="center"><a href="/index.php">Home</a></td>
          <td width="20px">&nbsp;</td>
          <td align="center"><a href="/news.html">News</a></td>
          <td width="20px">&nbsp;</td>
          <td align="center"><a href="/sitemap.html">Sitemap</a></td>
          <td width="30%">&nbsp;</td>
          <td align="center"><a href="/aboutme.html">About me</a></td>
          <td width="20px">&nbsp;</td>
          <td align="center"><a href="/aboutsite.html">About this site</a></td>
          <td width="20px">&nbsp;</td>
          <td align="center"><a href="/disclaimer.html">Disclaimer</a></td>
          <td width="20px">&nbsp;</td>
          <td align="center"><a href="mailto:info@streetinfo.lu">Contact</a></td>
        </tr>
      </table>
    </div>
    <div class="content">
      <h2>Site statistics for the last 7 days.</h2><br/>
      <?php
        // Connect to the database
        $user = 'stats'; $passwd = 'password';
        $pdo = new PDO('mysql:host=localhost;dbname=statistics', $user, $passwd);
        // Determine dates of last 7 days
        for ($i = 7; $i >= 1; $i--) {
          $day = mktime(0, 0, 0, date("m"), date("d") - $i + 1, date("Y"));
          $dates[7 - $i + 1] = date("Y", $day) . "-" . date("m", $day) . "-" . date("d", $day);
        }
        $firstdate = $dates[1]; $lastdate = $dates[7];
        // Query the database (for all sites and with 7 last days dates)
        $sql =  "SELECT site_url AS _site, access_date AS _date, access_count AS _count FROM web_sites, site_hits ";
        $sql .= "WHERE web_site = site_id ";
        $sql .= "  AND access_date >= '$firstdate' AND access_date <= '$lastdate' ";
        $sql .= "ORDER BY site_seqnum, access_date";
        $sth = $pdo->query($sql);
        // If there are database entries for these 7 days, display the visits counts (as HTML table)
        if ($sth->rowCount() > 0) {
          // Create (display) the HTML table
          echo '<table border="1" cellpadding="5">';
          // Table header
          echo '<tr>';
          echo '<th>Site url</th>';
          for ($i = 1; $i <= 7; $i++) {
            $dateparts = explode('-', $dates[$i]);
            $date = $dateparts[2] . '.' . $dateparts[1];
            echo '<th>' . $date . '</th>';
          }
          echo '<th>Total</th>';
          echo '</tr>';
          $oldsite = '';
          // Display a table entry for each record returned from the database
          while ($row = $sth->fetch(PDO::FETCH_ASSOC)) {
            // The daily counts for a given site will fill up a row in the table
            if ($row['_site'] != $oldsite) {
              // Record data contains "new" site URL
              if ($oldsite != '') {
                // Display the total count (for previous date)
                for ($j = $i; $j <=7; $j++) {
                  echo '<td>&nbsp;</td>';
                }
                echo '<td align="right">' . $total . '</td>';
                echo '</tr>';
              }
              echo '<tr>';
              echo '<td>' . $row['_site'] . '</td>';
              $oldsite = $row['_site'];
              $i = 1; $total = 0;
            }
            while ($row['_date'] > $dates[$i]) {
              // Days with 0 hits have no records; thus fill days fields with spaces, until
              // record returned actually has data for this day
              echo '<td>&nbsp;</td>';
              $i++;
            }
            // Now display the count for this day
            echo '<td align="right">' . $row['_count'] . '</td>';
            // Add all row counts for 7 days site total
            $i++; $total += $row['_count'];
          }
          // Display the last total count (was not yet done)
          for ($j = $i; $j <=7; $j++) {
            echo '<td>&nbsp;</td>';
          }
          echo '<td align="right">' . $total . '</td>';
          echo '</tr>';
          echo '</table>';
        }
        // If there are no database entries for these 7 days, display a message (instead of table)
        else {
          echo '<p>There are no site hits for the last 7 days...</p>';
        }
      ?>
    </div>
    <div class="clearfloat">
    </div>
  </div>
</body>

</html>
